<template>
  <highcharts ref="chart" :options="options"></highcharts>
</template>

<script>
import '@/plugins/highcharts.js'

export default {
  name: 'HighchartsColumn',
  props: {
    categories: {
      type: Array,
      default: function () {
        return []
      }
    },
    yAxisTitle: {
      type: String,
      default: ''
    },
    valueSuffix: {
      type: String,
      default: ''
    },
    valueDecimals: {
      type: Number,
      default: 0
    }
  },
  data () {
    return {
      options: {
        chart: {
          type: 'column'
        },
        title: {
          text: ''
        },
        credits: {
          enabled: false
        },
        series: [],
        tooltip: {
          shared: true,
          valueDecimals: this.valueDecimals,
          valueSuffix: ' ' + this.valueSuffix
        },
        xAxis: {
          categories: this.categories,
          crosshair: true
        },
        yAxis: {
          min: 0,
          title: {
            text: this.yAxisTitle
          }
        },
        exporting: {
          buttons: {
            contextButton: {
              menuItems: ['downloadPNG', 'downloadJPEG', 'downloadPDF', 'downloadSVG']
            }
          },
          chartOptions: {
            chart: {
              width: 750,
              height: 400
            }
          }
        }
      }
    }
  },
  methods: {
    setData: function (data, datai = null) {
      if (Array.isArray(data)) {
        // add error options
        if (Array.isArray(datai)) {
          datai.forEach(obj => {
            obj.name = 'Incertitude'
            obj.type = 'errorbar'
            obj.lineWidth = 2
            obj.tooltip = {
              pointFormat: '',
              enabled: false
            }
          })
        }
        if (data.length === 1) {
          data[0].showInLegend = false
        }
        // merge data and error, 1 by 1
        let finalData = []
        if (datai !== null) {
          for (let i = 0; i < data.length; i++) {
            finalData.push(data[i])
            finalData.push(datai[i])
          }
        } else {
          finalData = JSON.parse(JSON.stringify(data))
        }
        this.options.series = finalData
        this.$refs.chart.chart.redraw()
      }
    }
  }
}
</script>
